﻿/**
 * HabraRingtone v1.0
 * 
 * An ActionScript 3 implementation of Ringtone player
 * Copyright (c) 2008 Oleg Cherniy
 * 
 * License:
 *	   MIT-style license.
 */
package 
{
	import flash.external.ExternalInterface;
	import flash.display.Sprite; 

    import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	
	import com.ria.media.Ringtone;

	public class HabraRingtone extends Sprite
	{
		private var _ringtone:Ringtone;
		
		public function HabraRingtone() {
			 if (ExternalInterface.available) {
             	trace("Try to init ExternalInterface!");
                try {
					// Ringtone Playing
					ExternalInterface.addCallback("setRingtone", setRingtone);
					ExternalInterface.addCallback("playRingtone", playRingtone);
					ExternalInterface.addCallback("stopRingtone", stopRingtone);
					ExternalInterface.addCallback("setRingtoneValue", setRingtoneValue);
	             	trace("ExternalInterface init success!");
		            ExternalInterface.call("HabraRingtoneIsReady");
                } catch (error:SecurityError) {
                    trace("A SecurityError occurred: " + error.message);
                } catch (error:Error) {
                    trace("An Error occurred: " + error.message);
                }
			 } else {
             	trace("ExternalInterface is not available!");
			 }
			
			trace('Complete');
			//setRingtone("tone4.mp3");
			//playRingtone(3,5,100,60)
		}
		
		/**
		 * Установить имя файла рингтона
		 */
		private function setRingtone(fileName:String):void {
			_ringtone = new Ringtone(fileName);
		}
		
		/**
		 * Начать проигрывать рингтон
		 * @param count количество повторений рингтона, 0-будет иг
		 * @param volume    с какого уровня звука (в процентах) стартовать проигрывание рингтона
		 * @param volumeTo  до какого уровня звука (в процентах) усилять звук рингтона
		 * @param ringtoneAmplificationInterval время усиления звука (в секундах)
		 */
		public function playRingtone(count:int,volume:Number,volumeTo:Number,ringtoneAmplificationInterval:int) {
			_ringtone.play(count,volume,volumeTo,ringtoneAmplificationInterval);
		}
		
		
		/**
		 * Остановить проигрывание рингтона
		 */
		public function stopRingtone() {
			_ringtone.stop();
		}

		/**
		 * Изменить уровень звучания
		 * @param volume Уровень звучания в процентах
		 */
		public function setRingtoneValue(volume:Number) {
			_ringtone.setRingtoneValue(volume);
		}
	}
}